IBV_CREATE_SRQ(3)

NAME
ibv_create_srq, ibv_destroy_srq - create or destroy a shared receive queue (SRQ)

SYNOPSIS
#include <infiniband/verbs.h>

struct ibv_srq *ibv_create_srq(struct ibv_pd *pd, struct
                               ibv_srq_init_attr *srq_init_attr);

int ibv_destroy_srq(struct ibv_srq *srq);

DESCRIPTION
ibv_create_srq() creates a shared receive queue (SRQ) associated with the protection domain pd. The argument srq_init_attr is an ibv_srq_init_attr struct, as defined in <infiniband/verbs.h>.

struct ibv_srq_init_attr {
void                   *srq_context;    /* Associated context of the SRQ */
struct ibv_srq_attr     attr;           /* SRQ attributes */
};

struct ibv_srq_attr {
uint32_t                max_wr;         /* Requested max number of outstanding work requests (WRs) in the SRQ */
uint32_t                max_sge;        /* Requested max number of scatter elements per WR */
uint32_t                srq_limit;      /* The limit value of the SRQ (irrelevant for ibv_create_srq) */
};

The function ibv_create_srq() will update the srq_init_attr struct with the original values of the SRQ that was created; the values of max_wr and max_sge will be greater than or equal to the values requested.

ibv_destroy_srq() destroys the SRQ srq.

RETURN VALUE
ibv_create_srq() returns a pointer to the created SRQ, or NULL if the request fails.

ibv_destroy_srq() returns 0 on success, or the value of errno on failure (which indicates the failure reason).

NOTES
ibv_destroy_srq() fails if any queue pair is still associated with this SRQ.

SEE ALSO
ibv_alloc_pd(3), ibv_modify_srq(3), ibv_query_srq(3)

AUTHORS

Dotan Barak <dotanba@gmail.com>